package cn.jiguang.imui.messagelist;

import com.ecpei.widgets.modules.chat.CustomServiceModule;
import com.facebook.react.ReactPackage;
import com.facebook.react.bridge.JavaScriptModule;
import com.facebook.react.bridge.NativeModule;
import com.facebook.react.bridge.ReactApplicationContext;
import com.facebook.react.uimanager.ViewManager;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import cn.jiguang.imui.messagelist.viewmanager.ReactChatInputManager;
import cn.jiguang.imui.messagelist.viewmanager.ReactMsgListManager;

/**
 * Created by caiyaoguan on 2017/5/24.
 */

public class ReactIMUIPackage implements ReactPackage {

    @Override
    public List<NativeModule> createNativeModules(ReactApplicationContext reactContext) {
        List<NativeModule> nativeModules = new ArrayList<>();
        nativeModules.add(new AuroraIMUIModule(reactContext));
        nativeModules.add(new CustomServiceModule(reactContext));
        return nativeModules;
    }

    public List<Class<? extends JavaScriptModule>> createJSModules() {
        return Collections.emptyList();
    }

    @Override
    public List<ViewManager> createViewManagers(ReactApplicationContext reactContext) {
        List<ViewManager> viewManagers = new ArrayList<>();
        viewManagers.add(new ReactMsgListManager());
        viewManagers.add(new ReactChatInputManager());
        return  viewManagers;
    }
}
